<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/textwrap-0.15.0/src/word_separators.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>word_separators.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../textwrap/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
</pre><pre class="rust"><code><span class="doccomment">//! Functionality for finding words.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In order to wrap text, we need to know where the legal break</span>
<span class="doccomment">//! points are, i.e., where the words of the text are. This means that</span>
<span class="doccomment">//! we need to define what a &quot;word&quot; is.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! A simple approach is to simply split the text on whitespace, but</span>
<span class="doccomment">//! this does not work for East-Asian languages such as Chinese or</span>
<span class="doccomment">//! Japanese where there are no spaces between words. Breaking a long</span>
<span class="doccomment">//! sequence of emojis is another example where line breaks might be</span>
<span class="doccomment">//! wanted even if there are no whitespace to be found.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The [`WordSeparator`] trait is responsible for determining where</span>
<span class="doccomment">//! there words are in a line of text. Please refer to the trait and</span>
<span class="doccomment">//! the structs which implement it for more information.</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::core::skip_ansi_escape_sequence</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::core::Word</span>;

<span class="doccomment">/// Describes where words occur in a line of text.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The simplest approach is say that words are separated by one or</span>
<span class="doccomment">/// more ASCII spaces (`&#39; &#39;`). This works for Western languages</span>
<span class="doccomment">/// without emojis. A more complex approach is to use the Unicode line</span>
<span class="doccomment">/// breaking algorithm, which finds break points in non-ASCII text.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The line breaks occur between words, please see</span>
<span class="doccomment">/// [`WordSplitter`](crate::WordSplitter) for options of how to handle</span>
<span class="doccomment">/// hyphenation of individual words.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::Word;</span>
<span class="doccomment">/// use textwrap::WordSeparator::AsciiSpace;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let words = AsciiSpace.find_words(&quot;Hello World!&quot;).collect::&lt;Vec&lt;_&gt;&gt;();</span>
<span class="doccomment">/// assert_eq!(words, vec![Word::from(&quot;Hello &quot;), Word::from(&quot;World!&quot;)]);</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">WordSeparator</span> {
    <span class="doccomment">/// Find words by splitting on runs of `&#39; &#39;` characters.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// use textwrap::WordSeparator::AsciiSpace;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let words = AsciiSpace.find_words(&quot;Hello   World!&quot;).collect::&lt;Vec&lt;_&gt;&gt;();</span>
    <span class="doccomment">/// assert_eq!(words, vec![Word::from(&quot;Hello   &quot;),</span>
    <span class="doccomment">///                        Word::from(&quot;World!&quot;)]);</span>
    <span class="doccomment">/// ```</span>
    <span class="ident">AsciiSpace</span>,

    <span class="doccomment">/// Split `line` into words using Unicode break properties.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This word separator uses the Unicode line breaking algorithm</span>
    <span class="doccomment">/// described in [Unicode Standard Annex</span>
    <span class="doccomment">/// #14](https://www.unicode.org/reports/tr14/) to find legal places</span>
    <span class="doccomment">/// to break lines. There is a small difference in that the U+002D</span>
    <span class="doccomment">/// (Hyphen-Minus) and U+00AD (Soft Hyphen) don’t create a line break:</span>
    <span class="doccomment">/// to allow a line break at a hyphen, use</span>
    <span class="doccomment">/// [`WordSplitter::HyphenSplitter`](crate::WordSplitter::HyphenSplitter).</span>
    <span class="doccomment">/// Soft hyphens are not currently supported.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Unlike [`WordSeparator::AsciiSpace`], the Unicode line</span>
    <span class="doccomment">/// breaking algorithm will find line break opportunities between</span>
    <span class="doccomment">/// some characters with no intervening whitespace:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// #[cfg(feature = &quot;unicode-linebreak&quot;)] {</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// use textwrap::WordSeparator::UnicodeBreakProperties;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// assert_eq!(UnicodeBreakProperties.find_words(&quot;Emojis: 😂😍&quot;).collect::&lt;Vec&lt;_&gt;&gt;(),</span>
    <span class="doccomment">///            vec![Word::from(&quot;Emojis: &quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;😂&quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;😍&quot;)]);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// assert_eq!(UnicodeBreakProperties.find_words(&quot;CJK: 你好&quot;).collect::&lt;Vec&lt;_&gt;&gt;(),</span>
    <span class="doccomment">///            vec![Word::from(&quot;CJK: &quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;你&quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;好&quot;)]);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// A U+2060 (Word Joiner) character can be inserted if you want to</span>
    <span class="doccomment">/// manually override the defaults and keep the characters together:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// #[cfg(feature = &quot;unicode-linebreak&quot;)] {</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// use textwrap::WordSeparator::UnicodeBreakProperties;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// assert_eq!(UnicodeBreakProperties.find_words(&quot;Emojis: 😂\u{2060}😍&quot;).collect::&lt;Vec&lt;_&gt;&gt;(),</span>
    <span class="doccomment">///            vec![Word::from(&quot;Emojis: &quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;😂\u{2060}😍&quot;)]);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The Unicode line breaking algorithm will also automatically</span>
    <span class="doccomment">/// suppress break breaks around certain punctuation characters::</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// #[cfg(feature = &quot;unicode-linebreak&quot;)] {</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// use textwrap::WordSeparator::UnicodeBreakProperties;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// assert_eq!(UnicodeBreakProperties.find_words(&quot;[ foo ] bar !&quot;).collect::&lt;Vec&lt;_&gt;&gt;(),</span>
    <span class="doccomment">///            vec![Word::from(&quot;[ foo ] &quot;),</span>
    <span class="doccomment">///                 Word::from(&quot;bar !&quot;)]);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
    <span class="ident">UnicodeBreakProperties</span>,

    <span class="doccomment">/// Find words using a custom word separator</span>
    <span class="ident">Custom</span>(<span class="kw">fn</span>(<span class="ident">line</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;_</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span> <span class="ident">std::fmt::Debug</span> <span class="kw">for</span> <span class="ident">WordSeparator</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">std::fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">std::fmt::Result</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">WordSeparator::AsciiSpace</span> =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;AsciiSpace&quot;</span>),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
            <span class="ident">WordSeparator::UnicodeBreakProperties</span> =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;UnicodeBreakProperties&quot;</span>),
            <span class="ident">WordSeparator::Custom</span>(<span class="kw">_</span>) =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;Custom(...)&quot;</span>),
        }
    }
}

<span class="kw">impl</span> <span class="ident">WordSeparator</span> {
    <span class="comment">// This function should really return impl Iterator&lt;Item = Word&gt;, but</span>
    <span class="comment">// this isn&#39;t possible until Rust supports higher-kinded types:</span>
    <span class="comment">// https://github.com/rust-lang/rfcs/blob/master/text/1522-conservative-impl-trait.md</span>
    <span class="doccomment">/// Find all words in `line`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">find_words</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">line</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>) -&gt; <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">WordSeparator::AsciiSpace</span> =&gt; <span class="ident">find_words_ascii_space</span>(<span class="ident">line</span>),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
            <span class="ident">WordSeparator::UnicodeBreakProperties</span> =&gt; <span class="ident">find_words_unicode_break_properties</span>(<span class="ident">line</span>),
            <span class="ident">WordSeparator::Custom</span>(<span class="ident">func</span>) =&gt; <span class="ident">func</span>(<span class="ident">line</span>),
        }
    }
}

<span class="kw">fn</span> <span class="ident">find_words_ascii_space</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="ident">line</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>) -&gt; <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">start</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">in_whitespace</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">char_indices</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">char_indices</span>();

    <span class="ident">Box::new</span>(<span class="ident">std::iter::from_fn</span>(<span class="kw">move</span> <span class="op">|</span><span class="op">|</span> {
        <span class="comment">// for (idx, ch) in char_indices does not work, gives this</span>
        <span class="comment">// error:</span>
        <span class="comment">//</span>
        <span class="comment">// &gt; cannot move out of `char_indices`, a captured variable in</span>
        <span class="comment">// &gt; an `FnMut` closure</span>
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::while_let_on_iterator</span>)]</span>
        <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">idx</span>, <span class="ident">ch</span>)) <span class="op">=</span> <span class="ident">char_indices</span>.<span class="ident">next</span>() {
            <span class="kw">if</span> <span class="ident">in_whitespace</span> <span class="op">&amp;&amp;</span> <span class="ident">ch</span> <span class="op">!</span><span class="op">=</span> <span class="string">&#39; &#39;</span> {
                <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">line</span>[<span class="ident">start</span>..<span class="ident">idx</span>]);
                <span class="ident">start</span> <span class="op">=</span> <span class="ident">idx</span>;
                <span class="ident">in_whitespace</span> <span class="op">=</span> <span class="ident">ch</span> <span class="op">==</span> <span class="string">&#39; &#39;</span>;
                <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
            }

            <span class="ident">in_whitespace</span> <span class="op">=</span> <span class="ident">ch</span> <span class="op">==</span> <span class="string">&#39; &#39;</span>;
        }

        <span class="kw">if</span> <span class="ident">start</span> <span class="op">&lt;</span> <span class="ident">line</span>.<span class="ident">len</span>() {
            <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">line</span>[<span class="ident">start</span>..]);
            <span class="ident">start</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">len</span>();
            <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
        }

        <span class="prelude-val">None</span>
    }))
}

<span class="comment">// Strip all ANSI escape sequences from `text`.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
<span class="kw">fn</span> <span class="ident">strip_ansi_escape_sequences</span>(<span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">String</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span> <span class="op">=</span> <span class="ident">String::with_capacity</span>(<span class="ident">text</span>.<span class="ident">len</span>());

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">chars</span> <span class="op">=</span> <span class="ident">text</span>.<span class="ident">chars</span>();
    <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">ch</span>) <span class="op">=</span> <span class="ident">chars</span>.<span class="ident">next</span>() {
        <span class="kw">if</span> <span class="ident">skip_ansi_escape_sequence</span>(<span class="ident">ch</span>, <span class="kw-2">&amp;mut</span> <span class="ident">chars</span>) {
            <span class="kw">continue</span>;
        }
        <span class="ident">result</span>.<span class="ident">push</span>(<span class="ident">ch</span>);
    }

    <span class="ident">result</span>
}

<span class="doccomment">/// Soft hyphen, also knows as a “shy hyphen”. Should show up as ‘-’</span>
<span class="doccomment">/// if a line is broken at this point, and otherwise be invisible.</span>
<span class="doccomment">/// Textwrap does not currently support breaking words at soft</span>
<span class="doccomment">/// hyphens.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
<span class="kw">const</span> <span class="ident">SHY</span>: <span class="ident">char</span> <span class="op">=</span> <span class="string">&#39;\u{00ad}&#39;</span>;

<span class="doccomment">/// Find words in line. ANSI escape sequences are ignored in `line`.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
<span class="kw">fn</span> <span class="ident">find_words_unicode_break_properties</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(
    <span class="ident">line</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
) -&gt; <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="comment">// Construct an iterator over (original index, stripped index)</span>
    <span class="comment">// tuples. We find the Unicode linebreaks on a stripped string,</span>
    <span class="comment">// but we need the original indices so we can form words based on</span>
    <span class="comment">// the original string.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">last_stripped_idx</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">char_indices</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">char_indices</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">idx_map</span> <span class="op">=</span> <span class="ident">std::iter::from_fn</span>(<span class="kw">move</span> <span class="op">|</span><span class="op">|</span> <span class="kw">match</span> <span class="ident">char_indices</span>.<span class="ident">next</span>() {
        <span class="prelude-val">Some</span>((<span class="ident">orig_idx</span>, <span class="ident">ch</span>)) =&gt; {
            <span class="kw">let</span> <span class="ident">stripped_idx</span> <span class="op">=</span> <span class="ident">last_stripped_idx</span>;
            <span class="kw">if</span> <span class="op">!</span><span class="ident">skip_ansi_escape_sequence</span>(<span class="ident">ch</span>, <span class="kw-2">&amp;mut</span> <span class="ident">char_indices</span>.<span class="ident">by_ref</span>().<span class="ident">map</span>(<span class="op">|</span>(<span class="kw">_</span>, <span class="ident">ch</span>)<span class="op">|</span> <span class="ident">ch</span>)) {
                <span class="ident">last_stripped_idx</span> <span class="op">+</span><span class="op">=</span> <span class="ident">ch</span>.<span class="ident">len_utf8</span>();
            }
            <span class="prelude-val">Some</span>((<span class="ident">orig_idx</span>, <span class="ident">stripped_idx</span>))
        }
        <span class="prelude-val">None</span> =&gt; <span class="prelude-val">None</span>,
    });

    <span class="kw">let</span> <span class="ident">stripped</span> <span class="op">=</span> <span class="ident">strip_ansi_escape_sequences</span>(<span class="ident">line</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">opportunities</span> <span class="op">=</span> <span class="ident">unicode_linebreak::linebreaks</span>(<span class="kw-2">&amp;</span><span class="ident">stripped</span>)
        .<span class="ident">filter</span>(<span class="op">|</span>(<span class="ident">idx</span>, <span class="kw">_</span>)<span class="op">|</span> {
            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::match_like_matches_macro</span>)]</span>
            <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="ident">stripped</span>[..<span class="kw-2">*</span><span class="ident">idx</span>].<span class="ident">chars</span>().<span class="ident">next_back</span>() {
                <span class="comment">// We suppress breaks at ‘-’ since we want to control</span>
                <span class="comment">// this via the WordSplitter.</span>
                <span class="prelude-val">Some</span>(<span class="string">&#39;-&#39;</span>) =&gt; <span class="bool-val">false</span>,
                <span class="comment">// Soft hyphens are currently not supported since we</span>
                <span class="comment">// require all `Word` fragments to be continuous in</span>
                <span class="comment">// the input string.</span>
                <span class="prelude-val">Some</span>(<span class="ident">SHY</span>) =&gt; <span class="bool-val">false</span>,
                <span class="comment">// Other breaks should be fine!</span>
                <span class="kw">_</span> =&gt; <span class="bool-val">true</span>,
            }
        })
        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>()
        .<span class="ident">into_iter</span>();

    <span class="comment">// Remove final break opportunity, we will add it below using</span>
    <span class="comment">// &amp;line[start..]; This ensures that we correctly include a</span>
    <span class="comment">// trailing ANSI escape sequence.</span>
    <span class="ident">opportunities</span>.<span class="ident">next_back</span>();

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">start</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="ident">Box::new</span>(<span class="ident">std::iter::from_fn</span>(<span class="kw">move</span> <span class="op">|</span><span class="op">|</span> {
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::while_let_on_iterator</span>)]</span>
        <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">idx</span>, <span class="kw">_</span>)) <span class="op">=</span> <span class="ident">opportunities</span>.<span class="ident">next</span>() {
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">orig_idx</span>, <span class="kw">_</span>)) <span class="op">=</span> <span class="ident">idx_map</span>.<span class="ident">find</span>(<span class="op">|</span><span class="kw-2">&amp;</span>(<span class="kw">_</span>, <span class="ident">stripped_idx</span>)<span class="op">|</span> <span class="ident">stripped_idx</span> <span class="op">==</span> <span class="ident">idx</span>) {
                <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">line</span>[<span class="ident">start</span>..<span class="ident">orig_idx</span>]);
                <span class="ident">start</span> <span class="op">=</span> <span class="ident">orig_idx</span>;
                <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
            }
        }

        <span class="kw">if</span> <span class="ident">start</span> <span class="op">&lt;</span> <span class="ident">line</span>.<span class="ident">len</span>() {
            <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">line</span>[<span class="ident">start</span>..]);
            <span class="ident">start</span> <span class="op">=</span> <span class="ident">line</span>.<span class="ident">len</span>();
            <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
        }

        <span class="prelude-val">None</span>
    }))
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="ident"><span class="kw">super</span>::WordSeparator</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="comment">// Like assert_eq!, but the left expression is an iterator.</span>
    <span class="macro">macro_rules!</span> <span class="ident">assert_iter_eq</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">left</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">right</span>:<span class="ident">expr</span>) =&gt; {
            <span class="macro">assert_eq!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">left</span>.<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>(), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">right</span>);
        };
    }

    <span class="kw">fn</span> <span class="ident">to_words</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="ident">words</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span><span class="op">&gt;</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="ident">words</span>.<span class="ident">into_iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">w</span>: <span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">|</span> <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">w</span>)).<span class="ident">collect</span>()
    }

    <span class="macro">macro_rules!</span> <span class="ident">test_find_words</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">ascii_name</span>:<span class="ident">ident</span>,
         <span class="macro-nonterminal">$</span><span class="macro-nonterminal">unicode_name</span>:<span class="ident">ident</span>,
         $([ <span class="macro-nonterminal">$</span><span class="macro-nonterminal">line</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ascii_words</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">unicode_words</span>:<span class="ident">expr</span> ]),<span class="op">+</span>) =&gt; {
            <span class="attribute">#[<span class="ident">test</span>]</span>
            <span class="kw">fn</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ascii_name</span>() {
                $(
                    <span class="kw">let</span> <span class="ident">expected_words</span> <span class="op">=</span> <span class="ident">to_words</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">ascii_words</span>.<span class="ident">to_vec</span>());
                    <span class="kw">let</span> <span class="ident">actual_words</span> <span class="op">=</span> <span class="ident">WordSeparator::AsciiSpace</span>
                        .<span class="ident">find_words</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">line</span>)
                        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>();
                    <span class="macro">assert_eq!</span>(<span class="ident">actual_words</span>, <span class="ident">expected_words</span>, <span class="string">&quot;Line: {:?}&quot;</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">line</span>);
                )<span class="op">+</span>
            }

            <span class="attribute">#[<span class="ident">test</span>]</span>
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
            <span class="kw">fn</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">unicode_name</span>() {
                $(
                    <span class="kw">let</span> <span class="ident">expected_words</span> <span class="op">=</span> <span class="ident">to_words</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">unicode_words</span>.<span class="ident">to_vec</span>());
                    <span class="kw">let</span> <span class="ident">actual_words</span> <span class="op">=</span> <span class="ident">WordSeparator::UnicodeBreakProperties</span>
                        .<span class="ident">find_words</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">line</span>)
                        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>();
                    <span class="macro">assert_eq!</span>(<span class="ident">actual_words</span>, <span class="ident">expected_words</span>, <span class="string">&quot;Line: {:?}&quot;</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">line</span>);
                )<span class="op">+</span>
            }
        };
    }

    <span class="macro">test_find_words!</span>(<span class="ident">ascii_space_empty</span>, <span class="ident">unicode_empty</span>, [<span class="string">&quot;&quot;</span>, [], []]);

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_single_word</span>,
        <span class="ident">unicode_single_word</span>,
        [<span class="string">&quot;foo&quot;</span>, [<span class="string">&quot;foo&quot;</span>], [<span class="string">&quot;foo&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_two_words</span>,
        <span class="ident">unicode_two_words</span>,
        [<span class="string">&quot;foo bar&quot;</span>, [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;bar&quot;</span>], [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;bar&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_multiple_words</span>,
        <span class="ident">unicode_multiple_words</span>,
        [<span class="string">&quot;foo bar&quot;</span>, [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;bar&quot;</span>], [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;bar&quot;</span>]],
        [<span class="string">&quot;x y z&quot;</span>, [<span class="string">&quot;x &quot;</span>, <span class="string">&quot;y &quot;</span>, <span class="string">&quot;z&quot;</span>], [<span class="string">&quot;x &quot;</span>, <span class="string">&quot;y &quot;</span>, <span class="string">&quot;z&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_only_whitespace</span>,
        <span class="ident">unicode_only_whitespace</span>,
        [<span class="string">&quot; &quot;</span>, [<span class="string">&quot; &quot;</span>], [<span class="string">&quot; &quot;</span>]],
        [<span class="string">&quot;    &quot;</span>, [<span class="string">&quot;    &quot;</span>], [<span class="string">&quot;    &quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_inter_word_whitespace</span>,
        <span class="ident">unicode_inter_word_whitespace</span>,
        [<span class="string">&quot;foo   bar&quot;</span>, [<span class="string">&quot;foo   &quot;</span>, <span class="string">&quot;bar&quot;</span>], [<span class="string">&quot;foo   &quot;</span>, <span class="string">&quot;bar&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_trailing_whitespace</span>,
        <span class="ident">unicode_trailing_whitespace</span>,
        [<span class="string">&quot;foo   &quot;</span>, [<span class="string">&quot;foo   &quot;</span>], [<span class="string">&quot;foo   &quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_leading_whitespace</span>,
        <span class="ident">unicode_leading_whitespace</span>,
        [<span class="string">&quot;   foo&quot;</span>, [<span class="string">&quot;   &quot;</span>, <span class="string">&quot;foo&quot;</span>], [<span class="string">&quot;   &quot;</span>, <span class="string">&quot;foo&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_multi_column_char</span>,
        <span class="ident">unicode_multi_column_char</span>,
        [<span class="string">&quot;\u{1f920}&quot;</span>, [<span class="string">&quot;\u{1f920}&quot;</span>], [<span class="string">&quot;\u{1f920}&quot;</span>]] <span class="comment">// cowboy emoji 🤠</span>
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_hyphens</span>,
        <span class="ident">unicode_hyphens</span>,
        [<span class="string">&quot;foo-bar&quot;</span>, [<span class="string">&quot;foo-bar&quot;</span>], [<span class="string">&quot;foo-bar&quot;</span>]],
        [<span class="string">&quot;foo- bar&quot;</span>, [<span class="string">&quot;foo- &quot;</span>, <span class="string">&quot;bar&quot;</span>], [<span class="string">&quot;foo- &quot;</span>, <span class="string">&quot;bar&quot;</span>]],
        [<span class="string">&quot;foo - bar&quot;</span>, [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;- &quot;</span>, <span class="string">&quot;bar&quot;</span>], [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;- &quot;</span>, <span class="string">&quot;bar&quot;</span>]],
        [<span class="string">&quot;foo -bar&quot;</span>, [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;-bar&quot;</span>], [<span class="string">&quot;foo &quot;</span>, <span class="string">&quot;-bar&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_newline</span>,
        <span class="ident">unicode_newline</span>,
        [<span class="string">&quot;foo\nbar&quot;</span>, [<span class="string">&quot;foo\nbar&quot;</span>], [<span class="string">&quot;foo\n&quot;</span>, <span class="string">&quot;bar&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_tab</span>,
        <span class="ident">unicode_tab</span>,
        [<span class="string">&quot;foo\tbar&quot;</span>, [<span class="string">&quot;foo\tbar&quot;</span>], [<span class="string">&quot;foo\t&quot;</span>, <span class="string">&quot;bar&quot;</span>]]
    );

    <span class="macro">test_find_words!</span>(
        <span class="ident">ascii_non_breaking_space</span>,
        <span class="ident">unicode_non_breaking_space</span>,
        [<span class="string">&quot;foo\u{00A0}bar&quot;</span>, [<span class="string">&quot;foo\u{00A0}bar&quot;</span>], [<span class="string">&quot;foo\u{00A0}bar&quot;</span>]]
    );

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">unix</span>)]</span>
    <span class="kw">fn</span> <span class="ident">find_words_colored_text</span>() {
        <span class="kw">use</span> <span class="ident">termion::color</span>::{<span class="ident">Blue</span>, <span class="ident">Fg</span>, <span class="ident">Green</span>, <span class="ident">Reset</span>};

        <span class="kw">let</span> <span class="ident">green_hello</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{}Hello{} &quot;</span>, <span class="ident">Fg</span>(<span class="ident">Green</span>), <span class="ident">Fg</span>(<span class="ident">Reset</span>));
        <span class="kw">let</span> <span class="ident">blue_world</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{}World!{}&quot;</span>, <span class="ident">Fg</span>(<span class="ident">Blue</span>), <span class="ident">Fg</span>(<span class="ident">Reset</span>));
        <span class="macro">assert_iter_eq!</span>(
            <span class="ident">AsciiSpace</span>.<span class="ident">find_words</span>(<span class="kw-2">&amp;</span><span class="macro">format!</span>(<span class="string">&quot;{}{}&quot;</span>, <span class="ident">green_hello</span>, <span class="ident">blue_world</span>)),
            <span class="macro">vec!</span>[<span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">green_hello</span>), <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">blue_world</span>)]
        );

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
        <span class="macro">assert_iter_eq!</span>(
            <span class="ident">UnicodeBreakProperties</span>.<span class="ident">find_words</span>(<span class="kw-2">&amp;</span><span class="macro">format!</span>(<span class="string">&quot;{}{}&quot;</span>, <span class="ident">green_hello</span>, <span class="ident">blue_world</span>)),
            <span class="macro">vec!</span>[<span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">green_hello</span>), <span class="ident">Word::from</span>(<span class="kw-2">&amp;</span><span class="ident">blue_world</span>)]
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">find_words_color_inside_word</span>() {
        <span class="kw">let</span> <span class="ident">text</span> <span class="op">=</span> <span class="string">&quot;foo\u{1b}[0m\u{1b}[32mbar\u{1b}[0mbaz&quot;</span>;
        <span class="macro">assert_iter_eq!</span>(<span class="ident">AsciiSpace</span>.<span class="ident">find_words</span>(<span class="kw-2">&amp;</span><span class="ident">text</span>), <span class="macro">vec!</span>[<span class="ident">Word::from</span>(<span class="ident">text</span>)]);

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-linebreak&quot;</span>)]</span>
        <span class="macro">assert_iter_eq!</span>(
            <span class="ident">UnicodeBreakProperties</span>.<span class="ident">find_words</span>(<span class="kw-2">&amp;</span><span class="ident">text</span>),
            <span class="macro">vec!</span>[<span class="ident">Word::from</span>(<span class="ident">text</span>)]
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="textwrap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>